<?php

/**
 * Klasse General
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */
class Logging {
	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */

	function display() {
		require_once ('./includes/isgwtelnet.php');
		// args
		$m = $_GET['m'];

		$name = "LOGGING_TITLE_DIS";
		include('./includes/header.php');
		$general_table = $this->dynamic_table();
		// build page content
		$ret .= $general_table;
		$ret.='<script>
                    $("#logging").validate({
                    rules: {
                            port: {
                                digits: true,
                                range: [1,65535],
                            },
                    }
                });
                    $("#cifs").validate({
                    rules: {
                            cifs_log_share: {
                                required: "#cifs_log_enabled:checked",
                                sharePath: "#cifs_log_enabled:checked",
                            },
                            cifs_log_user: {
                                required: "#cifs_log_enabled:checked",
                            },
                            cifs_log_password: {
                                required: "#cifs_log_enabled:checked",
                            },
                    }
                });
		$( "#cifs_log_enabled" ).change(function() {
			required();
		});

		function required(){
			if ($("#cifs_log_enabled").is(":checked")) {
			    addAsterisk( "cifs_log_password" );
			    addAsterisk( "cifs_log_user" );
			    addAsterisk( "cifs_log_share" );
			}else{
			    deleteAsterisk("cifs_log_password");
			    deleteAsterisk( "cifs_log_user" );	  
			    deleteAsterisk( "cifs_log_share" );	  
			}
		}
		required();
                    </script>';
		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}

	/*
	 * Der reguläre Ausdruck, der in der Datenbank gespeichert ist wird zurückgegeben
	 * und nachher angezeigt.
	 */

	/*
	 * Die Adresse von dem Loging Server, die in der Datenbank gespeichert ist wird zurückgegeben
	 * und nachher angezeigt.
	 */

	function address() {
		$ba = new beroAri();
		$logserver = $ba->get("logserver");
		$ret = explode(":", $logserver);
		return $ret[0];
	}

	/*
	 * Syslog select box wird, mit den in der Datenbank gespeicherten Daten, erzeugt
	 * und nachher angezeigt.
	 */

	function syslog() {
		$ba = new beroAri();
		$option = $ba->get("syslog_facility");
		$sel = "<select name='syslog_facility' class='form-control'>";
		$j = 0;
		for ($i = 16; $i <= 23; $i++) {
			if ($option == $i)
				$sel.='<option value=\'' . $i . '\' selected>' . $i . ' - local ' . $j++ . '</option>';
			else
				$sel.='<option value=\'' . $i . '\'>' . $i . ' - local ' . $j++ . '</option>';
		}
		$sel.="</select>";
		return $sel;
	}

	/*
	 * Das Loglevel für Debuggingmode, das in der Datenbank gespeichert ist wird zurückgegeben
	 * und nachher angezeigt.
	 */

	function loglevel($log, $tooltip) {
		$ba = new beroAri();
		$loglevel = $ba->get($log);
		$ret.="<select name='$log' class='form-control' onmouseover=\"Tip('" . $tooltip . "')\" onmouseout='UnTip()'>";
		($log == "loglevel_message") ? $j = 2 : $j = 9;
		for ($i = 0; $i <= $j; $i++) {
			($i == $loglevel) ? $selected = "selected" : $selected = "";
			$ret.="<option value='$i' $selected>$i</option>";
		}
		$ret.="</select>";
		return $ret;
	}

	/*
	 * Das Port von dem Loging Server, das in der Datenbank gespeichert ist wird zurückgegeben
	 * und nachher angezeigt.
	 */

	function port() {
		$ba = new beroAri();
		$logserver = $ba->get("logserver");
		$ret = explode(":", $logserver);
		return $ret[1];
	}

	/*
	 * Der boolesche Wert von Loging Active, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */

	function active($log, $tooltip) {
		$ba = new beroAri();
		$active = $ba->get($log);
		($active == "1") ? $checked = "checked" : $checked = "";
		return "<input type='checkbox' name='$log' value='1' onmouseover=\"Tip('" . $tooltip . "')\" onmouseout='UnTip()' $checked>";
	}

	/*
	 * Der boolesche Wert von cifs enable, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */

	function cifs_enabled($bc) {
		$cifs_enabled = $bc->get("root", "cifs_log_enabled");
		if ($cifs_enabled == "1") {
			return "<input type='hidden' name='cifs_log_enabled' name='cifs_log_enabled' value='0'>"
				. "<input type='checkbox' name='cifs_log_enabled' id='cifs_log_enabled' value='1'  checked>";
		} else {
			return "<input type='hidden' name='cifs_log_enabled' value='0'>"
				. "<input type='checkbox' name='cifs_log_enabled' id='cifs_log_enabled' value='1'>";
		}
	}

	/*
	 * Der boolesche Wert von System, der in der root BD gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */

	function systemLog($bc) {
		$sysLog = $bc->get("root", "system-check-enabled");
		if ($sysLog == "1") {
			return "<input type='hidden' name='system-check-enabled' value='0'><input type='checkbox' name='system-check-enabled' value='1' checked>";
		} else {
			return "<input type='hidden' name='system-check-enabled' value='0'><input type='checkbox' name='system-check-enabled' value='1'>";
		}
	}

	//Änderungen des logging forms speichern
	private function _save_logging($bc) {
		$ba = new beroAri();


		if (($_POST['address'] != "") && ($_POST['port'] != "")) {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->logserver($_POST['address'], $_POST['port']);
			$ba->set("logserver",sqlite_escape_string($_POST['address'] . ":" . $_POST['port']));
		}

		if ($_POST['loglevel_debug'] != "") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->loglevel($_POST['loglevel_debug']);
			$ba->set("loglevel_debug",sqlite_escape_string($_POST['loglevel_debug']));
		}
		if ($_POST['loglevel_message'] != "") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->loglevel_message($_POST['loglevel_message']);
			$ba->set("loglevel_message",sqlite_escape_string($_POST['loglevel_message']));
		}

		if ($_POST['logging_message'] == "1") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->logactive_message(1);
			$ba->set("logging_message",1);
		} else {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->netlog(0);
			$isgw->logactive_message(0);
			$isgw->loglevel_message(0);
			$ba->set("logging_message",0);
			$ba->set("loglevel_message",0);
		}
		if ($_POST['logging_debug'] == "1") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->logactive(1);
			$ba->set("logging_debug",1);
		} else {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->logactive(0);
			$isgw->loglevel(0);
			$ba->set("logging_debug",0);
			$ba->set("loglevel_debug",0);
		}
		if ($_POST['logging_message'] == "1" || $_POST['logging_debug'] == "1") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->netlog(1);
			$ba->set("logging_active",1);
		} else {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->netlog(0);
			$isgw->loglevel_message(0);
			$isgw->loglevel(0);
			$ba->set("logging_active",0);
			$ba->set("loglevel_message",0);
			$ba->set("loglevel_debug",0);
		}

		if (isset($_POST['syslog_facility']) || isset($_POST['system-check-enabled'])) {
			//Nur wenn syslog facility verändert wurde, ist ein oranges activate erforderlich
			if ($ba->get('syslog_facility') != $_POST['syslog_facility'] || $bc->get("root", 'system-check-enabled') != $_POST['system-check-enabled']) {
				$table.=Helper::activate(2, true, $_GET['m'], ACTIVATE);
			}
			$ba->set("syslog_facility", sqlite_escape_string($_POST['syslog_facility']));
			$bc->set("root", "system-check-enabled", sqlite_escape_string($_POST['system-check-enabled']));
		} else {
			$ba->set("syslog_facility", "16");
			$table.=Helper::activate(2, true, $_GET['m'], ACTIVATE);
		}

		$table.=Helper::activate(1, true, $_GET['m'], ACTIVATE);
		return $table;
	}

	//Änderungen des cifs forms speichern
	private function _save_cifs($bc) {

		$bc->set('root', 'cifs_log_enabled', sqlite_escape_string($_POST['cifs_log_enabled']));
		$bc->set('root', 'cifs_log_share', sqlite_escape_string($_POST['cifs_log_share']));
		$bc->set('root', 'cifs_log_user', sqlite_escape_string($_POST['cifs_log_user']));
		$bc->set('root', 'cifs_log_password', sqlite_escape_string($_POST['cifs_log_password']));
		$bc->set('root', 'cifs_log_domain', sqlite_escape_string($_POST['cifs_log_domain']));
		$bc->set('root', 'cifs_log_size', sqlite_escape_string($_POST['cifs_log_size']));
		$bc->set('root', 'isgw_log_size', sqlite_escape_string(($_POST['cifs_log_size'] * 0.3 * 1000 / 2)));

		@exec('/etc/init.d/S41logcifsmount stop');

		return Helper::activate(3, true, $_GET['m'], ACTIVATE);
	}

	/*
	 * Funktion dynamic_table
	 */

	function dynamic_table() {
		require_once('/usr/fallback/beroConf.php');
		$bc = new beroConf('root');
		//Logging Änderungen speichern
		if (isset($_POST['address']) || isset($_POST['ports']) || isset($_POST['syslog_facility']))
			$table.=$this->_save_logging($bc);

		//CIFS Änderungen speichern
		if (isset($_POST['cifs_log_enabled']))
			$table.=$this->_save_cifs($bc);

		require_once("./includes/lang.php");
		$table .= "<form name='logging' id='logging' action='' method='POST'>
        <input type=hidden name=m value='" . $m . "'>
        <input type=hidden name=a value='save'>
        <br>
		<div class='table-responsive'>
        <table class='table table-striped table-bordered' id='table' >
        <tr>
        <th colspan='2'>" . LOGGING_TABLE_HEADER_DIS . "</th>
        </tr>
        <tr>
        <td><b>" . LOGGING_SERVER_DIS . ":</b></td>
        <td><input type='text' class='form-control' name='address' value='" . $this->address() . "' onmouseover=\"Tip('" . GENERAL_ADDRESS . "')\" onmouseout='UnTip()'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_SERVER_PORT_DIS . ":</b></td>
        <td><input type='text' name='port' class='form-control' value='" . $this->port() . "' onmouseover=\"Tip('" . GENERAL_PORT . "')\" onmouseout='UnTip()'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_MESSAGE_ACTIVE_DIS . ":</b></td>
        <td>" . $this->active('logging_message', LOGGING_MESSAGE_ACTIVE) . "</td>
        </tr>
        <tr>
        <td><b>" . LOGGING_MESSAGE_LEVEL_DIS . ":</b></td>
        <td>" . $this->loglevel('loglevel_message', LOGGING_MESSAGE_LOGLEVEL) . "</td>
        </tr>
        <tr>
        <td><b>" . LOGGING_DEBUG_ACTIVE_DIS . ":</b></td>
        <td>" . $this->active('logging_debug',LOGGING_DEBUG_ACTIVE) . "</td>
        </tr>
        <tr>
        <td><b>" . LOGGING_DEBUG_LEVEL_DIS . ":</b></td>
        <td>" . $this->loglevel('loglevel_debug', LOGGING_DEBUG_LOGLEVEL) . "</td>
        </tr>
        <tr>
        <td><b>" . LOGGING_SYSTEM_LOG_DIS . ":</b></td>
        <td>" . $this->systemLog($bc) . "</td>
        </tr>
        <tr>
        <td><b>" . LOGGING_SYSLOG_DIS . ":</b></td>
        <td>" . $this->syslog() . "</td>
        </tr>
        </table>
		</div>
		<div class='text-center'>
		<input name='submit' type='submit' class='btn btn-default' value='" . BUTTON_SAVE . "' onmouseover=\"Tip('" . GENERAL_SAVE . "')\" onmouseout='UnTip()'>
		</div>
        <br>
        </form>";

		if ($bc->get("root", "cifs_log_enabled")) {
			exec("/bin/mount", $res);
			$mount = implode(" ", $res);
			if (strpos($mount, "/var/log") !== false) {
				$testButton = '<input type=\'button\'  class=\'btn btn-default\' id=\'test\' value=\'Test CIFS share\'>'
					. '<script>$("#test").click(function() {
                $.ajax({url:"modules/Logginh/testCifs.php",success:function(result){
                    $(".testRes").html(result);
                }});
                });
                    </script>';
				$img = "<img src='./includes/images/punkt_gruen.gif'>";
			} else
				$img = "<img src='./includes/images/punkt_rot.gif'>";
			$state = "<tr>"
				. "<td><b>" . LOGGING_CIFS_STATUS_DIS . "</b></td>"
				. "<td>" . $img . "</td>"
				. "</tr>";
		}
		//CIFS Share
		$table .= "<div class='testRes text-center'></div>
			<form name='cifs' id='cifs' action='' method='POST'>
			<input name='fixChrome' type='password' style='display:none'>
        <input type=hidden name=m value='" . $m . "'>
        <input type=hidden name=a value='save'>
        <br>
		<div class='table-responsive'>
        <table class='table table-striped table-bordered' id='table'>
        <tr>
        <th colspan='2'>" . LOGGING_CIFS_TABLE_HEADER_DIS . "</th>
        </tr>"
			. $state .
			"<tr>
        <td><b>" . LOGGING_CIFS_ENABLED_DIS . ":</b></td>
        <td>" . $this->cifs_enabled($bc) . "</td>
        </tr>
        <tr>
        <tr>
        <td><b><label for='cifs_log_share'>" . LOGGING_CIFS_SHARE_DIS . ":</b></td>
        <td><input type='text' class='form-control' name='cifs_log_share' value='" . stripslashes($bc->get("root", "cifs_log_share")) . "' ></td>
        </tr>
        <tr>
        <td><b><label for='cifs_log_user'>" . LOGGING_CIFS_USER_DIS . "</label>:</b></td>
        <td><input type='text' class='form-control' name='cifs_log_user' value='" . $bc->get("root", "cifs_log_user") . "'></td>
        </tr>
        <tr>
        <td><b><label for='cifs_log_password'>" . LOGGING_CIFS_PASSWORD_DIS . "</label>:</b></td>
        <td><input type='password' class='form-control' name='cifs_log_password' autocomplete='new-password' value='" . $bc->get("root", "cifs_log_password") . "'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_CIFS_DOMAIN_DIS . ":</b></td>
        <td><input type='text' class='form-control' name='cifs_log_domain' value='" . $bc->get("root", "cifs_log_domain") . "'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_CIFS_SIZE_DIS . ":</b></td>
        <td><input type='text' class='form-control' name='cifs_log_size' value='" . (($bc->get('root', 'cifs_log_size') != '') ? '5000' : $bc->get('root', 'cifs_log_size')) . "'></td>
        </tr>
        <tr>
        <td colspan='2'>
        </td>
        </tr>
        </table>
		</div>
		<div class='text-center'>
		<input name='submit' class='btn btn-default' type='submit' value='" . BUTTON_SAVE . "' onmouseover=\"Tip('" . GENERAL_SAVE . "')\" onmouseout='UnTip()'>"
			. $testButton . "
		</div>
		<br>
		<div class='text-center'><i>".REQUIRED_FIELDS."</i></div>
        <br>
        </form>";
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
		return $table;
	}

}

?>
